<?php
/*
========================================================
 Plugin Textnest
--------------------------------------------------------
 Copyright: Oliver Heine
 http://gadgets.silenz.org/
--------------------------------------------------------
 ========================================================
 File: pi.textnest.php
--------------------------------------------------------
 Purpose: Manipulates {exp:weblog:categories}'s output
=========================================================

*/


$plugin_info = array(
						'pi_name'			=> 'Textnest',
						'pi_version'		=> '1.1',
						'pi_author'			=> 'Oliver Heine',
						'pi_author_url'		=> 'http://gadgets.silenz.org/index.php/gadgets/category/Plugins/',
						'pi_description'	=> 'Transforms an unordered nested list produced by {exp:weblog:categories} into pure text indented with &amp;nbsp; or other chars.',
						'pi_usage'			=> textnest::usage()
					);


class Textnest {

    var $return_data;
		function textnest($str = '')
    {
    	global $TMPL;

   		if ($str == '')	{	$str = $TMPL->tagdata;  }
   		$str = str_replace(SLASH, '/', $str." ");

			if ( !$TMPL->fetch_param('fill') ) $fill = "&nbsp;";
			else $fill = $TMPL->fetch_param('fill');


      $p = xml_parser_create();
      xml_parse_into_struct($p, $str, $vals, $index);
      xml_parser_free($p);

			$back = "";
      $le = array_keys($vals);
      foreach ($le as $key) {     

				if (isset($vals[$key]['value'])) $vals[$key]['value'] = trim($vals[$key]['value']);
        if (empty($vals[$key]['value']) || !isset($vals[$key]['value'])) unset ($vals[$key]);
        else {
        	
        	$it = ($vals[$key]['level']-3);
	        if ($it > 0) {
	        	for ($i = 1; $i <= $it; $i++) {
	          	$vals[$key]['value'] = $fill.$vals[$key]['value'];
	          }
	        }
        	unset($vals[$key]['level']);
	
        }
        
      }

      $back = $this->revert_vals($vals);
      $this->return_data = $back;
  	}

    function revert_vals($vals){
      $new_list = "";
      foreach($vals as $valobj){
        if($valobj['type']=='open' || $valobj['type']=='complete'){
        $new_list .= '<'.strtolower($valobj['tag']);
        if( isset($valobj['attributes']) && is_array($valobj['attributes'])){ 
            foreach($valobj['attributes'] as $key=>$val){
              $new_list .= " ".strtolower($key)."=\"$val\"";
            }
          }
        }
        if($valobj['type']=='open'){
          $new_list .= '>'.$valobj['value'];
        } elseif ($valobj['type']=='complete' && $valobj['value']) {
          $new_list .= '>'.$valobj['value'].'</'.strtolower($valobj['tag']).'>';
        } elseif($valobj['type']=='complete') {
          $new_list .= ' />';
        } elseif($valobj['type']=='cdata') {
          $new_list .= $valobj['value'];
        } elseif($valobj['type']=='close') {
          $new_list .= '</'.strtolower($valobj['tag']).'>';
        }
      }
      return $new_list;
    }
 
// ----------------------------------------
//  Plugin Usage
// ----------------------------------------

// This function describes how the plugin is used.
//  Make sure and use output buffering

function usage()
{
ob_start(); 
?>
Just wrap the tags around a pair of {exp:weblog:categories}-tags. 
It's supposed to work only with style="nested".


Example:

<p>Categories<br />
<select name="category[]" size="8" multiple="multiple">
{exp:textnest fill="&nbsp;&nbsp;"}
{exp:weblog:categories weblog="directory" category_group="2" style="nested"}
<option value="{category_id}">{exp:xml_encode}{category_name}{/exp:xml_encode}</option>
{/exp:weblog:categories}
{/exp:textnest}
</select>
</p>

Optional parameter:
fill=""
Determines what will be used to indent the subcategories. Defaults to &nbsp;

P.S.:
If your categories may contain special chars, better 
enclose the {category_name} variable in {exp:xml_encode}{/exp:xml_encode}.

<?php
$buffer = ob_get_contents();
	
ob_end_clean(); 

return $buffer;
}
/* END */


}
// END CLASS
?>
